import * as MC from "@minecraft/server";

const amulets = [
  ["dustveyn:ore_amulets.diamond_amulet", "minecraft:diamond_ore", "minecraft:deepslate_diamond_ore", "dustveyn:ore_amulets.diamond_instinct"],
  ["dustveyn:ore_amulets.iron_amulet", "minecraft:iron_ore", "minecraft:deepslate_iron_ore", "dustveyn:ore_amulets.iron_instinct"],
  ["dustveyn:ore_amulets.gold_amulet", "minecraft:gold_ore", "minecraft:deepslate_gold_ore", "dustveyn:ore_amulets.gold_instinct"],
  ["dustveyn:ore_amulets.coal_amulet", "minecraft:coal_ore", "minecraft:deepslate_coal_ore", "dustveyn:ore_amulets.coal_instinct"],
  ["dustveyn:ore_amulets.copper_amulet", "minecraft:copper_ore", "minecraft:deepslate_copper_ore", "dustveyn:ore_amulets.copper_instinct"],
  ["dustveyn:ore_amulets.emerald_amulet", "minecraft:emerald_ore", "minecraft:deepslate_emerald_ore", "dustveyn:ore_amulets.emerald_instinct"],
  ["dustveyn:ore_amulets.redstone_amulet", "minecraft:redstone_ore", "minecraft:deepslate_redstone_ore", "dustveyn:ore_amulets.redstone_instinct"],
  ["dustveyn:ore_amulets.netherite_amulet", "minecraft:ancient_debris", "minecraft:ancient_debris", "dustveyn:ore_amulets.netherite_instinct"],
  ["dustveyn:ore_amulets.lapis_lazuli_amulet", "minecraft:lapis_ore", "minecraft:deepslate_lapis_ore", "dustveyn:ore_amulets.lapis_instinct"]
];

function* generator() {
  //Get the players on the world
  var Players = MC.world.getAllPlayers()

  for (let player of Players) {
    const equipment = player.getComponent("equippable")
    const itemHand = equipment.getEquipment("Mainhand")
    const itemOffhand = equipment.getEquipment("Offhand")
    for (const amulet of amulets) {
      if (itemHand?.typeId == amulet[0] || itemOffhand?.typeId == amulet[0]) {
        for (let x = -6; x <= 6; x++) {
          for (let y = -6; y <= 6; y++) {
            for (let z = -6; z <= 6; z++) {
              let block = player.dimension.getBlock({
                x: Math.floor(player.location.x) + x,
                y: Math.floor(player.location.y) + y,
                z: Math.floor(player.location.z) + z
              });

              if (!block || !block.isValid) continue
              
              let entities = block.dimension.getEntitiesAtBlockLocation(block.location)

              if (!entities.length && block?.typeId == amulet[1] || block?.typeId == amulet[2]) {
                
                block.dimension.spawnEntity(amulet[3],block.bottomCenter())
                
                break;
              }
            }
          }
        }
      }
    }
  }
}

function WorldTick() {
  //Safe execution
  MC.system.runJob(generator())
}

//Initial Tick
MC.system.runInterval(WorldTick,3)